/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void MapCB();
static void UnmapCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, rowcol, button1, button2, button3, button4;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    XtSetArg(al[ac], XmNallowShellResize, True); ac++;
    toplevel = XtAppInitialize(&app_context, "Unmap", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    button1 = XmCreatePushButton(rowcol, "button1", al, ac);
    XtManageChild(button1);

    ac = 0;
    button2 = XmCreatePushButton(rowcol, "button2", al, ac);
    XtManageChild(button2);

    ac = 0;
    button3 = XmCreatePushButton(rowcol, "button3", al, ac);
    XtManageChild(button3);

    ac = 0;
    button4 = XmCreatePushButton(rowcol, "button4", al, ac);
    XtManageChild(button4);

    /* Map the button3 when button1 is pressed */
    XtAddCallback(button1, XmNactivateCallback, MapCB, button3);
    /* Unmap the button3 when button2 is pressed */
    XtAddCallback(button2, XmNactivateCallback, UnmapCB, button3);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

static void MapCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget button = (Widget)client_data;

    XtMapWidget(button); /* Map the button */
}

static void UnmapCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget button = (Widget)client_data;

    XtUnmapWidget(button); /* Unmap the button */
}
